//UART.c Datei mit den RS232 Funktionen										 //
//																			 //
//Andreas Wenzel 19.06.2007													 //
///////////////////////////////////////////////////////////////////////////////

#include "UART.h"
#include <avr\io.h>

// Initialiserungsfunktion

void UART_init()
{
	uint16_t baud;
	baud = F_CPU / (UART_BAUD_RATE * 16L) - 1;	//Berechnung der BAUD-Rate
	DDRD |= (1<<RXD)|(0<<TXD);					//Richtung der UART-Leitungen
	UBRRH = (unsigned char) (baud>>8);			//Einstellen der BAUD-Rate
	UBRRL =	(unsigned char) baud;
	UCSRB |= (1<<TXEN);							//UART+Interrupt aktivieren
	UCSRC |= (1<<URSEL)|(3<<UCSZ0);				//8bit, keine Paritt
}

// Einfache Senderoutine

void UART_send(char data)						//Ein zeichen senden
{
	while (!(UCSRA & (1<<UDRE)));				//auf IDLE warten
	UDR=data;									//Senden
}

// Zeichenkette Schreiben

void UART_print(char *string)					//String senden
{
	while(*string)								
	{
		UART_send(*string);						//Byteweise senden
		string++;								//nchstes BYTE
	}
}


